package com.easyproject.core.web.service;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import javax.servlet.http.HttpServletRequest;

import com.easyproject.common.core.domain.model.LoginMember;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import com.easyproject.common.constant.CacheConstants;
import com.easyproject.common.constant.Constants;
import com.easyproject.common.core.redis.RedisCache;
import com.easyproject.common.utils.ServletUtils;
import com.easyproject.common.utils.StringUtils;
import com.easyproject.common.utils.ip.AddressUtils;
import com.easyproject.common.utils.ip.IpUtils;
import com.easyproject.common.utils.uuid.IdUtils;
import eu.bitwalker.useragentutils.UserAgent;
import io.jsonwebtoken.Claims;
import io.jsonwebtoken.Jwts;
import io.jsonwebtoken.SignatureAlgorithm;

/**
 * token验证处理
 *
 * @author java001
 */
@Component
public class MemberTokenService
{
    // 是否允许账户多终端同时登录（true允许 false不允许）
    @Value("${token.soloLogin}")
    private boolean soloLogin;

    // 令牌自定义标识
    @Value("${token.header}")
    private String header;

    // 令牌秘钥
    @Value("${token.secret}")
    private String secret;

    // 令牌有效期（默认7天）
    @Value("${token.expireTime}")
    private int expireTime;

    protected static final long MILLIS_SECOND = 1000;

    protected static final long MILLIS_MINUTE = 60 * MILLIS_SECOND;

    private static final Long MILLIS_MINUTE_TEN = 20 * 60 * 1000L;

    @Autowired
    private RedisCache redisCache;

    /**
     * 获取用户身份信息
     *
     * @return 用户信息
     */
    public LoginMember getLoginMember(HttpServletRequest request)
    {
        // 获取请求携带的令牌
        String token = getToken(request);
        if (StringUtils.isNotEmpty(token))
        {
            try
            {
                Claims claims = parseToken(token);
                // 解析对应的权限以及用户信息
                String uuid = (String) claims.get(Constants.LOGIN_MEMBER_KEY);
                String userKey = getTokenKey(uuid);
                //System.out.println("使用token的key ===>  "+userKey);
                LoginMember user = redisCache.getCacheObject(userKey);
                return user;
            }
            catch (Exception e)
            {
            }
        }
        return null;
    }

    /**
     * 设置用户身份信息
     * 修改信息、重置密码、头像 调用 相当于更新
     */
    public void setLoginUser(LoginMember loginMember)
    {
        if (StringUtils.isNotNull(loginMember) && StringUtils.isNotEmpty(loginMember.getToken()))
        {
            refreshToken(loginMember);
        }
    }

    /**
     * 删除用户身份信息
     */
    public void delLoginUser(String token,Long userId)
    {
        if (StringUtils.isNotEmpty(token))
        {
            String userKey = getTokenKey(token);
            redisCache.deleteObject(userKey);
        }
        if (!soloLogin && StringUtils.isNotNull(userId))
        {
            String userIdKey = getUserIdKey(userId);
            redisCache.deleteObject(userIdKey);
        }
    }

    private String getUserIdKey(Long userId)
    {
        return Constants.LOGIN_USERID_KEY + userId;
    }

    /**
     * 创建令牌
     *
     * @param loginMember 用户信息
     * @return 令牌
     */
    public String createToken(LoginMember loginMember)
    {
        String token = IdUtils.fastUUID();
        loginMember.setToken(token);
        setUserAgent(loginMember);
        refreshToken(loginMember);

        Map<String, Object> claims = new HashMap<>();
        claims.put(Constants.LOGIN_MEMBER_KEY, token);
        return createToken(claims);
    }

    /**
     * 验证令牌有效期，相差不足20分钟，自动刷新缓存
     *
     * @param loginMember
     * @return 令牌
     */
    public void verifyToken(LoginMember loginMember)
    {
        long expireTime = loginMember.getExpireTime();
        long currentTime = System.currentTimeMillis();
        if (expireTime - currentTime <= MILLIS_MINUTE_TEN)
        {
            refreshToken(loginMember);
        }
    }

    /**
     * 刷新令牌有效期
     *
     * @param loginMember 登录信息
     */
    public void refreshToken(LoginMember loginMember)
    {
        loginMember.setLoginTime(System.currentTimeMillis());
        loginMember.setExpireTime(loginMember.getLoginTime() + expireTime * MILLIS_MINUTE);
        // 根据uuid将loginUser缓存
        String userKey = getTokenKey(loginMember.getToken());
        //System.out.println("创建token 的 key ===> " +userKey);
        redisCache.setCacheObject(userKey, loginMember, expireTime, TimeUnit.MINUTES);
        if (!soloLogin)
        {
            // 缓存用户唯一标识，防止同一帐号，同时登录
            String userIdKey = getUserIdKey(loginMember.getMember().getId());
            redisCache.setCacheObject(userIdKey, userKey, expireTime, TimeUnit.MINUTES);
        }
    }

    /**
     * 设置用户代理信息
     *
     * @param loginMember 登录信息
     */
    public void setUserAgent(LoginMember loginMember)
    {
        UserAgent userAgent = UserAgent.parseUserAgentString(ServletUtils.getRequest().getHeader("User-Agent"));
        String ip = IpUtils.getIpAddr(ServletUtils.getRequest());
        loginMember.setIpaddr(ip);
        loginMember.setLoginLocation(AddressUtils.getRealAddressByIP(ip));
        loginMember.setBrowser(userAgent.getBrowser().getName());
        loginMember.setOs(userAgent.getOperatingSystem().getName());
    }

    /**
     * 从数据声明生成令牌
     *
     * @param claims 数据声明
     * @return 令牌
     */
    private String createToken(Map<String, Object> claims)
    {
        String token = Jwts.builder()
                .setClaims(claims)
                .signWith(SignatureAlgorithm.HS512, secret).compact();
        return token;
    }

    /**
     * 从令牌中获取数据声明
     *
     * @param token 令牌
     * @return 数据声明
     */
    private Claims parseToken(String token)
    {
        return Jwts.parser()
                .setSigningKey(secret)
                .parseClaimsJws(token)
                .getBody();
    }

    /**
     * 从令牌中获取用户名
     *
     * @param token 令牌
     * @return 用户名
     */
    public String getUsernameFromToken(String token)
    {
        Claims claims = parseToken(token);
        return claims.getSubject();
    }

    /**
     * 获取请求token
     *
     * @param request
     * @return token
     */
    private String getToken(HttpServletRequest request)
    {
        String token = request.getHeader(header);
        if (StringUtils.isNotEmpty(token) && token.startsWith(Constants.TOKEN_PREFIX))
        {
            token = token.replace(Constants.TOKEN_PREFIX, "");
        }
        return token;
    }

    private String getTokenKey(String uuid)
    {
        return CacheConstants.CLIENT_LOGIN_TOKEN_KEY + uuid;
    }
}
